/**
*  @license
* Copyright 2021, JsData. All rights reserved.
*
* This source code is licensed under the MIT license found in the
* LICENSE file in the root directory of this source tree.

* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
* ==========================================================================
*/
import { SGDRegressor } from './sgdRegressor.js';
export interface LassoParams {
    /** Whether or not the intercept should be estimator not. **default = true** */
    fitIntercept?: boolean;
    /** Constant that multiplies the L1 term. **defaults = 1.0** */
    alpha?: number;
}
/** Linear Model trained with L1 prior as regularizer (aka the Lasso). */
export declare class LassoRegression extends SGDRegressor {
    /** Useful for pipelines and column transformers to have a default name for transforms */
    name: string;
    constructor({ fitIntercept, alpha }?: LassoParams);
}
