var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { optimizer, initializer, getLoss } from '../utils.js';
import { tf } from '../shared-esm/globals.js';
import { OneHotEncoder } from '../preprocessing/oneHotEncoder.js';
function getModelWeight(model) {
    return Promise.all(model.getWeights().map(function (weight) { return weight.array(); }));
}
export function toJSON(classConstructor, classifierJson) {
    return __awaiter(this, void 0, void 0, function () {
        var modelConfig, modelWeight, initializerName, biasName;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    modelConfig = classConstructor.model.getConfig();
                    return [4 /*yield*/, getModelWeight(classConstructor.model)];
                case 1:
                    modelWeight = _a.sent();
                    classifierJson.model = {
                        config: modelConfig,
                        weight: modelWeight
                    };
                    if (classConstructor.denseLayerArgs.kernelInitializer) {
                        initializerName = classConstructor.denseLayerArgs.kernelInitializer.constructor.name;
                        classifierJson.denseLayerArgs.kernelInitializer = initializerName;
                    }
                    if (classConstructor.denseLayerArgs.biasInitializer) {
                        biasName = classConstructor.denseLayerArgs.biasInitializer.constructor.name;
                        classifierJson.denseLayerArgs.biasInitializer = biasName;
                    }
                    // set optimizer
                    classifierJson.modelCompileArgs.optimizer =
                        classConstructor.model.optimizer.getConfig();
                    return [2 /*return*/, JSON.stringify(classifierJson)];
            }
        });
    });
}
export function fromJson(classConstructor, model) {
    var e_1, _a;
    var jsonClass = JSON.parse(model);
    if (jsonClass.name != classConstructor.name) {
        throw new Error("wrong json values for ".concat(classConstructor.name, " constructor"));
    }
    var jsonModel = tf.Sequential.fromConfig(tf.Sequential, jsonClass.model.config);
    var jsonOpt = optimizer(jsonClass.optimizerType);
    var optim = Object.assign(jsonOpt, jsonClass.modelCompileArgs.optimizer);
    var loss = getLoss(jsonClass.lossType);
    jsonClass.modelCompileArgs = __assign(__assign({}, jsonClass.modelCompileArgs), { optimizer: optim, loss: loss });
    jsonModel.compile(jsonClass.modelCompileArgs);
    var weights = [];
    try {
        for (var _b = __values(jsonClass.model.weight), _c = _b.next(); !_c.done; _c = _b.next()) {
            var weight = _c.value;
            weights.push(tf.tensor(weight));
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    jsonModel.setWeights(weights);
    jsonClass.model = jsonModel;
    // if call back create callback
    // default usecase is set to EarlyStop
    // might get complex for custom callback
    if (jsonClass.modelFitArgs.callbacks) {
        var jsonCallback = tf.callbacks.earlyStopping();
        var modelFitArgs = jsonClass.modelFitArgs;
        jsonCallback = Object.assign(jsonCallback, modelFitArgs.callbacks[0]);
        modelFitArgs.callbacks = [jsonCallback];
    }
    if (jsonClass.denseLayerArgs.kernelInitializer) {
        var initializerName = jsonClass.denseLayerArgs.kernelInitializer;
        jsonClass.denseLayerArgs.kernelInitializer = initializer(initializerName);
    }
    if (jsonClass.denseLayerArgs.biasInitializer) {
        var biasName = jsonClass.denseLayerArgs.biasInitializer;
        jsonClass.denseLayerArgs.biasInitializer = initializer(biasName);
    }
    if (jsonClass.oneHot) {
        var jsonOneHotEncoder = new OneHotEncoder();
        jsonClass.oneHot = Object.assign(jsonOneHotEncoder, jsonClass.oneHot);
    }
    return Object.assign(classConstructor, jsonClass);
}
