/**
 * A Generic class to serialized and Unserialized classes (models, transformers,
 * or any operator)
 */
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { tf } from './shared-esm/globals.js';
var Serialize = /** @class */ (function () {
    function Serialize() {
        this.name = 'Serialize'; // default name for all inherited class
    }
    /**
     * Serialize all [inherited] class property into
     * a json string
     * @returns Json string
     */
    Serialize.prototype.toJson = function () {
        var e_1, _a;
        var thisCopy = Object.assign({}, this);
        try {
            for (var _b = __values(Object.keys(thisCopy)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var key = _c.value;
                var value = thisCopy[key];
                if (value instanceof tf.Tensor) {
                    thisCopy[key] = {
                        type: 'Tensor',
                        value: value.arraySync()
                    };
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return JSON.stringify(thisCopy);
    };
    /**
     * Initialize [inherited] class from serialized
     * json string
     * @param model string
     * @returns [Inherited] Class
     */
    Serialize.prototype.fromJson = function (model) {
        var e_2, _a;
        var jsonClass = JSON.parse(model);
        if (jsonClass.name != this.name) {
            throw new Error("wrong json values for ".concat(this.name, " constructor"));
        }
        try {
            for (var _b = __values(Object.keys(jsonClass)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var key = _c.value;
                var value = jsonClass[key];
                if (typeof value === 'object' && (value === null || value === void 0 ? void 0 : value.type) === 'Tensor') {
                    jsonClass[key] = tf.tensor(jsonClass[key].value);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return Object.assign(this, jsonClass);
    };
    return Serialize;
}());
export default Serialize;
