"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecisionTreeRegressor = exports.DecisionTreeClassifier = exports.GaussianNB = exports.LinearSVR = exports.LinearSVC = exports.VotingClassifier = exports.makeVotingClassifier = exports.VotingRegressor = exports.makeVotingRegressor = exports.dataUrls = exports.KMeans = exports.RobustScaler = exports.ColumnTransformer = exports.makePipeline = exports.Pipeline = exports.Normalizer = exports.OrdinalEncoder = exports.LabelEncoder = exports.OneHotEncoder = exports.SimpleImputer = exports.MaxAbsScaler = exports.StandardScaler = exports.MinMaxScaler = exports.DummyClassifier = exports.DummyRegressor = exports.metrics = exports.LogisticRegression = exports.ElasticNet = exports.RidgeRegression = exports.LassoRegression = exports.LinearRegression = exports.KNeighborsRegressor = void 0;
/**
*  @license
* Copyright 2021, JsData. All rights reserved.
*
* This source code is licensed under the MIT license found in the
* LICENSE file in the root directory of this source tree.

* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
* ==========================================================================
*/
var kNeighborsRegressor_1 = require("./neighbors/kNeighborsRegressor.js");
Object.defineProperty(exports, "KNeighborsRegressor", { enumerable: true, get: function () { return kNeighborsRegressor_1.KNeighborsRegressor; } });
var linearRegression_1 = require("./linear_model/linearRegression.js");
Object.defineProperty(exports, "LinearRegression", { enumerable: true, get: function () { return linearRegression_1.LinearRegression; } });
var lassoRegression_1 = require("./linear_model/lassoRegression.js");
Object.defineProperty(exports, "LassoRegression", { enumerable: true, get: function () { return lassoRegression_1.LassoRegression; } });
var ridgeRegression_1 = require("./linear_model/ridgeRegression.js");
Object.defineProperty(exports, "RidgeRegression", { enumerable: true, get: function () { return ridgeRegression_1.RidgeRegression; } });
var elasticNet_1 = require("./linear_model/elasticNet.js");
Object.defineProperty(exports, "ElasticNet", { enumerable: true, get: function () { return elasticNet_1.ElasticNet; } });
var logisticRegression_1 = require("./linear_model/logisticRegression.js");
Object.defineProperty(exports, "LogisticRegression", { enumerable: true, get: function () { return logisticRegression_1.LogisticRegression; } });
exports.metrics = __importStar(require("./metrics/metrics.js"));
var dummyRegressor_1 = require("./dummy/dummyRegressor.js");
Object.defineProperty(exports, "DummyRegressor", { enumerable: true, get: function () { return dummyRegressor_1.DummyRegressor; } });
var dummyClassifier_1 = require("./dummy/dummyClassifier.js");
Object.defineProperty(exports, "DummyClassifier", { enumerable: true, get: function () { return dummyClassifier_1.DummyClassifier; } });
var minMaxScaler_1 = require("./preprocessing/minMaxScaler.js");
Object.defineProperty(exports, "MinMaxScaler", { enumerable: true, get: function () { return minMaxScaler_1.MinMaxScaler; } });
var standardScaler_1 = require("./preprocessing/standardScaler.js");
Object.defineProperty(exports, "StandardScaler", { enumerable: true, get: function () { return standardScaler_1.StandardScaler; } });
var maxAbsScaler_1 = require("./preprocessing/maxAbsScaler.js");
Object.defineProperty(exports, "MaxAbsScaler", { enumerable: true, get: function () { return maxAbsScaler_1.MaxAbsScaler; } });
var simpleImputer_1 = require("./impute/simpleImputer.js");
Object.defineProperty(exports, "SimpleImputer", { enumerable: true, get: function () { return simpleImputer_1.SimpleImputer; } });
var oneHotEncoder_1 = require("./preprocessing/oneHotEncoder.js");
Object.defineProperty(exports, "OneHotEncoder", { enumerable: true, get: function () { return oneHotEncoder_1.OneHotEncoder; } });
var labelEncoder_1 = require("./preprocessing/labelEncoder.js");
Object.defineProperty(exports, "LabelEncoder", { enumerable: true, get: function () { return labelEncoder_1.LabelEncoder; } });
var ordinalEncoder_1 = require("./preprocessing/ordinalEncoder.js");
Object.defineProperty(exports, "OrdinalEncoder", { enumerable: true, get: function () { return ordinalEncoder_1.OrdinalEncoder; } });
var normalizer_1 = require("./preprocessing/normalizer.js");
Object.defineProperty(exports, "Normalizer", { enumerable: true, get: function () { return normalizer_1.Normalizer; } });
var pipeline_1 = require("./pipeline/pipeline.js");
Object.defineProperty(exports, "Pipeline", { enumerable: true, get: function () { return pipeline_1.Pipeline; } });
Object.defineProperty(exports, "makePipeline", { enumerable: true, get: function () { return pipeline_1.makePipeline; } });
var columnTransformer_1 = require("./compose/columnTransformer.js");
Object.defineProperty(exports, "ColumnTransformer", { enumerable: true, get: function () { return columnTransformer_1.ColumnTransformer; } });
var robustScaler_1 = require("./preprocessing/robustScaler.js");
Object.defineProperty(exports, "RobustScaler", { enumerable: true, get: function () { return robustScaler_1.RobustScaler; } });
var kmeans_1 = require("./cluster/kmeans.js");
Object.defineProperty(exports, "KMeans", { enumerable: true, get: function () { return kmeans_1.KMeans; } });
var datasets_1 = require("./datasets/datasets.js");
Object.defineProperty(exports, "dataUrls", { enumerable: true, get: function () { return datasets_1.dataUrls; } });
var votingRegressor_1 = require("./ensemble/votingRegressor.js");
Object.defineProperty(exports, "makeVotingRegressor", { enumerable: true, get: function () { return votingRegressor_1.makeVotingRegressor; } });
Object.defineProperty(exports, "VotingRegressor", { enumerable: true, get: function () { return votingRegressor_1.VotingRegressor; } });
var votingClassifier_1 = require("./ensemble/votingClassifier.js");
Object.defineProperty(exports, "makeVotingClassifier", { enumerable: true, get: function () { return votingClassifier_1.makeVotingClassifier; } });
Object.defineProperty(exports, "VotingClassifier", { enumerable: true, get: function () { return votingClassifier_1.VotingClassifier; } });
var linearSVC_1 = require("./svm/linearSVC.js");
Object.defineProperty(exports, "LinearSVC", { enumerable: true, get: function () { return linearSVC_1.LinearSVC; } });
var linearSVR_1 = require("./svm/linearSVR.js");
Object.defineProperty(exports, "LinearSVR", { enumerable: true, get: function () { return linearSVR_1.LinearSVR; } });
// Comment these out until our libsvm version doesn't ship with fs / path subdependencies
// They were stopping the browser build from being built
// export { SVR, SVRParams } from './svm/SVR.js'
// export { SVC, SVCParams } from './svm/SVC.js'
var gaussianNaiveBayes_1 = require("./naive_bayes/gaussianNaiveBayes.js");
Object.defineProperty(exports, "GaussianNB", { enumerable: true, get: function () { return gaussianNaiveBayes_1.GaussianNB; } });
var decisiontree_1 = require("./tree/decisiontree.js");
Object.defineProperty(exports, "DecisionTreeClassifier", { enumerable: true, get: function () { return decisiontree_1.DecisionTreeClassifier; } });
Object.defineProperty(exports, "DecisionTreeRegressor", { enumerable: true, get: function () { return decisiontree_1.DecisionTreeRegressor; } });
