import { Iterable } from './types.js';
import { tf } from './shared-node/globals.js';
export declare function simpleMin<T extends Iterable<number | string | boolean>>(arr: T, ignoreNaN?: boolean): number | string | boolean;
export declare function tensorMin(tensor: tf.Tensor, axis: number, ignoreNaN: boolean): tf.Tensor;
export declare function simpleMax<T extends Iterable<number | string | boolean>>(arr: T, ignoreNaN?: boolean): number | string | boolean;
export declare function tensorMax(tensor: tf.Tensor, axis: number, ignoreNaN?: boolean): tf.Tensor;
export declare function simpleSum<T extends Iterable<number | boolean>>(arr: T, ignoreNaN?: boolean): number;
export declare function tensorSum(tensor: tf.Tensor, axis: number, ignoreNaN?: boolean): tf.Tensor<tf.Rank>;
export declare function simpleCount<T extends Iterable<number | string | boolean>>(arr: T, ignoreNaN?: boolean): number;
export declare function tensorCount(tensor: tf.Tensor, axis: number, ignoreNaN?: boolean): tf.Tensor<tf.Rank>;
export declare function simpleMean<T extends Iterable<number | boolean>>(arr: T): number;
export declare function tensorMean(tensor: tf.Tensor, axis: number, ignoreNaN?: boolean, safe?: boolean): tf.Tensor<tf.Rank>;
export declare function tensorStd(tensor: tf.Tensor, dim: number, ignoreNaN?: boolean): tf.Tensor<tf.Rank>;
export declare function turnZerosToOnes(tensor: tf.Tensor): tf.Tensor<tf.Rank>;
